// ChangeUserPinDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ChangeUserPin.h"
#include "ChangeUserPinDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

void i2aHex(unsigned char i/*[in]*/,char* buff/*[out]*/)
{
	unsigned char t = i>>4;
	i&=0x0F;
	
	if(t<=9)
	{
		buff[0]=t+'0';
	}
	else
	{
		buff[0]=t+'A'-10;
	}
	t=i&0x0f;
	if(t<=9)
	{
		buff[1]=t+'0';
	}
	else
	{
		buff[1]=t+'A'-10;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChangeUserPinDlg dialog

CChangeUserPinDlg::CChangeUserPinDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChangeUserPinDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChangeUserPinDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CChangeUserPinDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChangeUserPinDlg)
	DDX_Control(pDX, BUTTON_SET, m_btnSet);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CChangeUserPinDlg, CDialog)
	//{{AFX_MSG_MAP(CChangeUserPinDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(BUTTON_EXIT, OnExit)
	ON_BN_CLICKED(BUTTON_SET, OnSet)
	ON_EN_CHANGE(EDIT_PID, OnChangePid)
	ON_EN_CHANGE(EDIT_OLDUSERPIN, OnChangeOlduserpin)
	ON_EN_CHANGE(EDIT_NEWUSERPIN, OnChangeNewuserpin)
	ON_EN_CHANGE(EDIT_CONFIRMUSERPIN, OnChangeConfirmuserpin)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChangeUserPinDlg message handlers

BOOL CChangeUserPinDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CChangeUserPinDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CChangeUserPinDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CChangeUserPinDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CChangeUserPinDlg::OnExit() 
{
	CDialog::OnOK();
}

void CChangeUserPinDlg::OnSet() 
{
	// 
	unsigned char longPid[8];
	int tokenCount;
	ET_HANDLE hET99;
	unsigned long ret = ET_SUCCESS;
	unsigned char oldUserPin[16];
	unsigned char newUserPin[16];
	unsigned char confirmUserPin[16];

	GetDlgItemText(EDIT_PID,CPid);
	GetDlgItemText(EDIT_OLDUSERPIN,COldUserPin);
	GetDlgItemText(EDIT_NEWUSERPIN,CNewUserPin);
	GetDlgItemText(EDIT_CONFIRMUSERPIN,CConfirmUserPin);

	memcpy(longPid,CPid.GetBuffer(0),8);
	memcpy(oldUserPin,COldUserPin.GetBuffer(0),16);
	memcpy(newUserPin,CNewUserPin.GetBuffer(0),16);
	memcpy(confirmUserPin,CConfirmUserPin.GetBuffer(8),16);

	ret = et_FindToken(longPid,&tokenCount);
	if(ET_SUCCESS!=ret)
	{
		MessageBox("ҲָET99!","ChangeUserPin",MB_OK|MB_ICONSTOP);
		return;
	}
	else
	{
		if(1!=tokenCount)
		{
			MessageBox("ҵָET99ֹ1 !","ChangeUserPin",MB_OK|MB_ICONSTOP);
			return;
		}
	}
	ret = et_OpenToken(&hET99,longPid,1);
	if(ET_SUCCESS!=ret)
	{
		MessageBox("ET99ʧ!","ChangeUserPin",MB_OK|MB_ICONSTOP);
		return;
	}
	ret = et_ChangeUserPIN(hET99,oldUserPin,newUserPin);
	if(ET_SUCCESS!=ret)
	{
		if(ret == ET_NOT_SET_PID)
			MessageBox("㻹ûET99PID!","ChangeUserPin",MB_OK|MB_ICONSTOP);
		else
			MessageBox("ıûPIN!","ChangeUserPin",MB_OK|MB_ICONSTOP);
		et_CloseToken(hET99);
		return;
	}

	MessageBox("ıûPINɹ!","ChangeUserPin",MB_OK);
	et_CloseToken(hET99);
}

void CChangeUserPinDlg::OnChangePid() 
{
	GetDlgItemText(EDIT_PID,CPid);
	GetDlgItemText(EDIT_OLDUSERPIN,COldUserPin);
	GetDlgItemText(EDIT_NEWUSERPIN,CNewUserPin);
	GetDlgItemText(EDIT_CONFIRMUSERPIN,CConfirmUserPin);

	if((8!=CPid.GetLength())||(16!=COldUserPin.GetLength())||(16!=CNewUserPin.GetLength())||(16!=CConfirmUserPin.GetLength())||(CNewUserPin!=CConfirmUserPin))
		m_btnSet.EnableWindow(FALSE);
	else
		m_btnSet.EnableWindow(TRUE);
}

void CChangeUserPinDlg::OnOK() 
{
	// TODO: Add extra validation here
	
//	CDialog::OnOK();
}

void CChangeUserPinDlg::OnChangeOlduserpin() 
{
	GetDlgItemText(EDIT_PID,CPid);
	GetDlgItemText(EDIT_OLDUSERPIN,COldUserPin);
	GetDlgItemText(EDIT_NEWUSERPIN,CNewUserPin);
	GetDlgItemText(EDIT_CONFIRMUSERPIN,CConfirmUserPin);

	if((8!=CPid.GetLength())||(16!=COldUserPin.GetLength())||(16!=CNewUserPin.GetLength())||(16!=CConfirmUserPin.GetLength())||(CNewUserPin!=CConfirmUserPin))
		m_btnSet.EnableWindow(FALSE);
	else
		m_btnSet.EnableWindow(TRUE);
	
}

void CChangeUserPinDlg::OnChangeNewuserpin() 
{
	GetDlgItemText(EDIT_PID,CPid);
	GetDlgItemText(EDIT_OLDUSERPIN,COldUserPin);
	GetDlgItemText(EDIT_NEWUSERPIN,CNewUserPin);
	GetDlgItemText(EDIT_CONFIRMUSERPIN,CConfirmUserPin);

	if((8!=CPid.GetLength())||(16!=COldUserPin.GetLength())||(16!=CNewUserPin.GetLength())||(16!=CConfirmUserPin.GetLength())||(CNewUserPin!=CConfirmUserPin))
		m_btnSet.EnableWindow(FALSE);
	else
		m_btnSet.EnableWindow(TRUE);
	
}

void CChangeUserPinDlg::OnChangeConfirmuserpin() 
{
	GetDlgItemText(EDIT_PID,CPid);
	GetDlgItemText(EDIT_OLDUSERPIN,COldUserPin);
	GetDlgItemText(EDIT_NEWUSERPIN,CNewUserPin);
	GetDlgItemText(EDIT_CONFIRMUSERPIN,CConfirmUserPin);

	if((8!=CPid.GetLength())||(16!=COldUserPin.GetLength())||(16!=CNewUserPin.GetLength())||(16!=CConfirmUserPin.GetLength())||(CNewUserPin!=CConfirmUserPin))
		m_btnSet.EnableWindow(FALSE);
	else
		m_btnSet.EnableWindow(TRUE);
	
}
